Task Labels in EJ2 JavaScript Gantt Chart Control

27 May 202612 minutes to read

Task labels in the EJ2 JavaScript Gantt Chart control display key task information directly on or near taskbars, enhancing project visualization without requiring task interaction. Configured via the labelSettings property, labels show details like task names, IDs, or progress, streamlining workflows for resource management and status tracking. Labels support three positions: left labels outside the taskbar for identifiers like TaskName, right labels after the taskbar for metrics like Progress, and task labels overlaid on taskbars for prominent data like task titles. Left and right labels remain visible regardless of taskbar width, while task labels may clip for short tasks. Labels improve readability and provide immediate context, reducing the need for hovers or dialogs in large projects.

Configure task labels

Task labels are configured using the labelSettings property, mapping fields from the data source defined in taskFields (e.g., id to TaskID, name to TaskName). The control supports three label positions with specific use cases:

  • leftLabel: Displays content like task names or resource assignments to the left of taskbars, ideal for identifiers.
  • rightLabel: Shows metrics like progress percentages or durations to the right, suitable for completion data.
  • taskLabel: Overlays content like task titles or progress on taskbars, prominent but limited by taskbar width.

Use template literals for formatted labels, such as ${Progress}% for progress percentages. Ensure valid taskFields mappings to reference fields accurately.

The following example configures labels for task names, IDs, and progress:

  const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    parentID: 'ParentID'
  };
  const labelSettings = {
    leftLabel: 'Task Id: ${TaskID}',
    rightLabel: 'Task Name: ${TaskName}',
    taskLabel: '${Progress}%'
  };

This code displays task names on the left, task IDs on the right, and formatted progress percentages on taskbars, ensuring clear visualization.

Customize labels with templates

For advanced scenarios, you can create custom label templates using functions for advanced customization that provide complete control over label content and formatting.

var ganttChart = new ej.gantt.Gantt({
    dataSource: GanttData,
    height: '450px',
    projectStartDate: new Date('03/31/2019'),
    projectEndDate: new Date('04/18/2019'),
    taskFields: {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    },
    labelSettings: {
        leftLabel: 'Task ID: ${TaskID}',
        rightLabel: 'Task Name: ${taskData.TaskName}',
        taskLabel: '${Progress}%'
    }
});

ganttChart.appendTo('#Gantt');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Gantt</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Gantt Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css">
    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
    <script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="Gantt"></div>
    </div>
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

This code creates a left label with priority-based icons (e.g., red for high priority) and a right label with a progress bar, improving visual feedback. For responsive designs, ensure templates adapt to narrow screens, as task labels may be clipped on short taskbars.

Conditional label display with icons:

Create templates that show different content based on task properties:

function leftLabelTemplate(props) {
    var priorityIcon = '';

    if (props.Priority === 'High') {
        priorityIcon = '<span class="priority-high">🔴</span>';
    } else if (props.Priority === 'Medium') {
        priorityIcon = '<span class="priority-medium">🟡</span>';
    } else if (props.Priority === 'Low') {
        priorityIcon = '<span class="priority-low">🟢</span>';
    }

    return (
        '<div class="custom-left-label">' +
            priorityIcon +
            '<span>' + props.TaskName + '</span>' +
        '</div>'
    );
}

function rightLabelTemplate(props) {
    var progress = props.Progress || 0;
    var duration = props.Duration || 0;

    return (
        '<div class="custom-right-label">' +
            '<div class="progress-container">' +
                '<span class="progress-text">' + progress + '%</span>' +
                '<div class="progress-bar" style="width:' + progress + '%"></div>' +
            '</div>' +
            '<span class="duration-text">' + duration + ' days</span>' +
        '</div>'
    );
}

var ganttChart = new ej.gantt.Gantt({
    dataSource: GanttData,
    height: '450px',
    taskFields: {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    },
    labelSettings: {
        leftLabel: leftLabelTemplate,
        rightLabel: rightLabelTemplate
    }
});

ganttChart.appendTo('#Gantt');

Rich content labels with multiple data points:

Display complex information with formatted content and calculations:

function getProgressClass(progress) {
    if (progress >= 80) {
        return 'high';
    }
    if (progress >= 40) {
        return 'medium';
    }
    return 'low';
}

function formatDate(date) {
    if (!date) {
        return '';
    }
    return date.toLocaleDateString('en-US', {
        month: 'short',
        day: '2-digit'
    });
}

function taskLabelTemplate(props) {
    var taskName = props.TaskName || (props.ganttProperties && props.ganttProperties.taskName);
    var startDate = props.StartDate || (props.ganttProperties && props.ganttProperties.startDate);
    var endDate = props.EndDate || (props.ganttProperties && props.ganttProperties.endDate);
    var progress = (props.Progress != null)
        ? props.Progress
        : (props.ganttProperties && props.ganttProperties.progress) || 0;
    var resources = props.Resources || (props.ganttProperties && props.ganttProperties.resourceInfo);

    var resourceHtml = '';
    if (resources && resources.length) {
        resourceHtml =
            '<span class="resource-count">👥 ' + resources.length + '</span>';
    }

    return (
        '<div class="rich-task-label">' +
            '<div class="task-info">' +
                '<strong>' + taskName + '</strong>' +
                '<small>' +
                    formatDate(startDate) + ' – ' + formatDate(endDate) +
                '</small>' +
            '</div>' +
            '<div class="task-meta">' +
                resourceHtml +
                '<span class="progress-badge progress-' + getProgressClass(progress) + '">' +
                    progress + '%' +
                '</span>' +
            '</div>' +
        '</div>'
    );
}

var ganttChart = new ej.gantt.Gantt({
    dataSource: GanttData,
    height: '450px',
    taskFields: {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    },
    labelSettings: {
        taskLabel: taskLabelTemplate
    }
});

ganttChart.appendTo('#Gantt');

See also

Task Labels in Angular Gantt Chart Component

4 Jul 202617 minutes to read

Task labels in the Angular Gantt Chart component display key task information directly on or near taskbars, enhancing project visualization without requiring task interaction. Configured via the labelSettings property, labels show details like task names, IDs, or progress, streamlining workflows for resource management and status tracking. Labels support three positions: left labels outside the taskbar for identifiers like TaskName, right labels after the taskbar for metrics like Progress, and task labels overlaid on taskbars for prominent data like task titles. Left and right labels remain visible regardless of taskbar width, while task labels may clip for short tasks. Labels improve readability and provide immediate context, reducing the need for hovers or dialogs in large projects.

Configure task labels

Task labels are configured using the labelSettings property, mapping fields from the data source defined in taskFields (e.g., id to TaskID, name to TaskName). The component supports three label positions with specific use cases:

  • leftLabel: Displays content like task names or resource assignments to the left of taskbars, ideal for identifiers.
  • rightLabel: Shows metrics like progress percentages or durations to the right, suitable for completion data.
  • taskLabel: Overlays content like task titles or progress on taskbars, prominent but limited by taskbar width.

Use template literals for formatted labels, such as ${Progress}% for progress percentages. Ensure valid taskFields mappings to reference fields accurately.

The following example configures labels for task names, IDs, and progress:

export class AppComponent {
  public taskSettings: object = {
    id: "TaskID",
    name: "TaskName",
    startDate: "StartDate",
    duration: "Duration",
    progress: "Progress",
    dependency: "Predecessor",
    child: "subtasks",
  };

  public labelSettings: object = {
    leftLabel: "TaskName",
    rightLabel: "TaskID",
    taskLabel: "${Progress}%",
  };

  public data: object[] = [
    // Task data array.
  ];
}

This code displays task names on the left, task IDs on the right, and formatted progress percentages on taskbars, ensuring clear visualization.

Customize labels with templates

For advanced scenarios, you can create custom label templates that provide complete control over label content and formatting

import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { GanttModule } from '@syncfusion/ej2-angular-gantt'
import { projectNewData } from './data';

@Component({
    imports: [GanttModule],
    standalone: true,
    selector: 'app-root',
    template:
        `<ejs-gantt height="430px" [dataSource]="taskData" [taskFields]="taskSettings"  [labelSettings]="labelSettings"  [projectStartDate]="projectStartDate"  [projectEndDate]="projectEndDate">
        </ejs-gantt>`,
    encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
    public taskData?: object[];
    public taskSettings?: object;
    public labelSettings?: object;
    public columns?: object[];
    public projectStartDate?: Date;
    public projectEndDate?: Date;

    public ngOnInit(): void {
        this.taskData = projectNewData;
        this.taskSettings = {
            id: 'TaskId',
            name: 'TaskName',
            startDate: 'StartDate',
            duration: 'Duration',
            progress: 'Progress',
            parentID: 'ParentId',
        };
        this.labelSettings = {
            leftLabel: 'Task Id: ${taskData.TaskId}',
            rightLabel: 'Progress Value: ${taskData.Progress}',
            taskLabel: '${Progress}%'
        }
        this.projectStartDate = new Date('03/28/2019');
        this.projectEndDate = new Date('04/18/2019');
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));
/**
 * Gantt Chart DataSource
 */

export let projectNewData: Object[] = [
    { TaskId: 1, TaskName: 'Product Concept', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019'), },
    { TaskId: 2, TaskName: 'Defining the product and its usage', StartDate: new Date('04/02/2019'), Duration: 3, Progress: 30, ParentId: 1 },
    { TaskId: 3, TaskName: 'Defining target audience', StartDate: new Date('04/02/2019'), Duration: 3, ParentId: 1 },
    { TaskId: 4, TaskName: 'Prepare product sketch and notes', StartDate: new Date('04/02/2019'), Duration: 2, Predecessor: '2', Progress: 30, ParentId: 1 },
    { TaskId: 5, TaskName: 'Concept Approval', StartDate: new Date('04/02/2019'), Duration: 0, Predecessor: '3,4', Indicators: [ { 'date': '04/10/2019', 'name': '#briefing', 'title': 'Product concept breifing', }]},
    { TaskId: 6, TaskName: 'Market Research',StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019'), },
    { TaskId: 7, TaskName: 'Demand Analysis', StartDate: new Date('04/04/2019'), EndDate: new Date('04/21/2019'), ParentId: 6,},
    { TaskId: 8, TaskName: 'Customer strength', StartDate: new Date('04/04/2019'), Duration: 4, Predecessor: '5', Progress: 30, ParentId: 7, },
    { TaskId: 9, TaskName: 'Market opportunity analysis', StartDate: new Date('04/04/2019'), Duration: 4, Predecessor: '5', ParentId: 7,  },
    { TaskId: 10, TaskName: 'Competitor Analysis', StartDate: new Date('04/04/2019'), Duration: 4, Predecessor: '7, 8', Progress: 30, ParentId: 6, },
    { TaskId: 11, TaskName: 'Product strength analysis', StartDate: new Date('04/04/2019'), Duration: 4, Predecessor: '9', ParentId: 6, },
    { TaskId: 12, TaskName: 'Research complete', StartDate: new Date('04/04/2019'), Duration: 0, Predecessor: '10', ParentId: 6, Indicators: [ { 'date': '04/20/2019', 'name': '#meeting', 'title': '1st board of directors meeting', } ] },
    { TaskId: 13, TaskName: 'Product Design and Development', StartDate: new Date('04/04/2019'), EndDate: new Date('04/21/2019'), },
    { TaskId: 14, TaskName: 'Functionality design', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 30, Predecessor: '12', ParentId: 13, },
    { TaskId: 15, TaskName: 'Quality design', StartDate: new Date('04/04/2019'), Duration: 3, Predecessor: '12', ParentId: 13, },
    { TaskId: 16, TaskName: 'Define Reliability', StartDate: new Date('04/04/2019'), Duration: 2, Progress: 30, Predecessor: '15', ParentId: 13, },
    { TaskId: 17, TaskName: 'Identifying raw materials', StartDate: new Date('04/04/2019'), Duration: 2, Predecessor: '15', ParentId: 13, },
    { TaskId: 18, TaskName: 'Define cost plan', StartDate: new Date('04/04/2019'), EndDate: new Date('04/21/2019'), ParentId: 13 },
    { TaskId: 19, TaskName: 'Manufacturing cost', StartDate: new Date('04/04/2019'), Duration: 2, Progress: 30, Predecessor: '17', ParentId: 18, },
    { TaskId: 20, TaskName: 'Selling cost', StartDate: new Date('04/04/2019'), Duration: 2, Predecessor: '17', ParentId: 18, },
    { TaskId: 21, TaskName: 'Development of the final design', StartDate: new Date('04/04/2019'), EndDate: new Date('04/21/2019'), ParentId: 13, },
    { TaskId: 22, TaskName: 'Defining dimensions and package volume', StartDate: new Date('04/04/2019'), Duration: 2, Progress: 30, Predecessor: '19,20', ParentId: 21, },
    { TaskId: 23, TaskName: 'Develop design to meet industry standards', StartDate: new Date('04/04/2019'), Duration: 2, Predecessor: '22', ParentId: 21, },
    { TaskId: 24, TaskName: 'Include all the details', StartDate: new Date('04/04/2019'), Duration: 3, Predecessor: '23', ParentId: 21, },
    { TaskId: 25, TaskName: 'CAD Computer-aided design', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 30, Predecessor: '24',  ParentId: 13, },
    { TaskId: 26, TaskName: 'CAM Computer-aided manufacturing', StartDate: new Date('04/04/2019'), Duration: 3, Predecessor: '25', ParentId: 13, },
    { TaskId: 27, TaskName: 'Design complete', StartDate: new Date('04/04/2019'), Duration: 0, Predecessor: '26', ParentId: 13, Indicators: [ { 'date': '05/18/2019', 'name': '#meeting', 'title': '2nd board of directors meeting', } ] },
    { TaskId: 28, TaskName: 'Prototype Testing', StartDate: new Date('04/04/2019'), Duration: 4, Progress: 30, Predecessor: '27' },
    { TaskId: 29, TaskName: 'Include feedback', StartDate: new Date('04/04/2019'), Duration: 4, Predecessor: '28ss' },
    { TaskId: 30, TaskName: 'Manufacturing', StartDate: new Date('04/04/2019'), Duration: 5, Progress: 30, Predecessor: '28,29' },
    { TaskId: 31, TaskName: 'Assembling materials to finished goods', StartDate: new Date('04/04/2019'), Duration: 5, Predecessor: '30' },
    { TaskId: 32, TaskName: 'Feedback and Testing', StartDate: new Date('04/04/2019'), EndDate: new Date('04/21/2019'), },
    { TaskId: 33, TaskName: 'Internal testing and feedback', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 45, Predecessor: '31', ParentId: 32, },
    { TaskId: 34,  TaskName: 'Customer testing and feedback', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50, Predecessor: '33', ParentId: 32, },
    { TaskId: 35, TaskName: 'Final Product Development', StartDate: new Date('04/04/2019'), EndDate: new Date('04/21/2019'), },
    { TaskId: 36, TaskName: 'Important improvements', StartDate: new Date('04/04/2019'), Duration: 4, Progress: 30, Predecessor: '34',  ParentId: 35, },
    { TaskId: 37, TaskName: 'Address any unforeseen issues', StartDate: new Date('04/04/2019'), Duration: 4, Progress: 30, Predecessor: '36ss',  ParentId: 35, },
    { TaskId: 38, TaskName: 'Final Product', StartDate: new Date('04/04/2019'), EndDate: new Date('04/21/2019'), },
    { TaskId: 39, TaskName: 'Branding product', StartDate: new Date('04/04/2019'), Duration: 4, Predecessor: '37', ParentId: 38 },
    { TaskId: 40, TaskName: 'Marketing and presales', StartDate: new Date('04/04/2019'), Duration: 4, Progress: 30, Predecessor: '39', ParentId: 38 }
];

This code creates a left label with priority-based icons (e.g., red for high priority) and a right label with a progress bar, improving visual feedback. For responsive designs, ensure templates adapt to narrow screens, as task labels may be clipped on short taskbars.

Conditional label display with icons:

Create templates that show different content based on task properties:

// Left label template with conditional logic.
public leftLabelTemplate: string = `
    <div class="custom-left-label">
        <span *ngIf="data.Priority === 'High'" class="priority-high">🔴</span>
        <span *ngIf="data.Priority === 'Medium'" class="priority-medium">🟡</span>
        <span *ngIf="data.Priority === 'Low'" class="priority-low">🟢</span>
        
    </div>
`;

// Right label template with progress indicators.
public rightLabelTemplate: string = `
    <div class="custom-right-label">
        <div class="progress-container">
            <span class="progress-text">%</span>
            <div class="progress-bar" [style.width.%]="data.Progress"></div>
        </div>
        <span class="duration-text"> days</span>
    </div>
`;
public ngOnInit(): void {
    this.labelSettings = {
            leftLabel: leftLabelTemplate,
            rightLabel: rightLabelTemplate
    }
}

Rich content labels with multiple data points:

Display complex information with formatted content and calculations:

// Task label template with multiple data points.
public taskLabelTemplate: string = `
    <div class="rich-task-label">
        <div class="task-info">
            <strong></strong>
            <small> - </small>
        </div>
        <div class="task-meta">
            <span class="resource-count" *ngIf="data.Resources">
                👥 
            </span>
            <span class="progress-badge"
                  [class]="'progress-' + getProgressClass(data.Progress)">
                %
            </span>
        </div>
    </div>
`;
public ngOnInit(): void {
    this.labelSettings = {
            taskLabel: taskLabelTemplate
    }
}


// Component method for progress classification.
getProgressClass(progress: number): string {
    if (progress >= 80) return 'high';
    if (progress >= 40) return 'medium';
    return 'low';
}

See also

Task Labels in React Gantt Chart Component

2 Jul 202612 minutes to read

Task labels in the React Gantt Chart component display key task information directly on or near taskbars, enhancing project visualization without requiring task interaction. Configured via the labelSettings property, labels show details like task names, IDs, or progress, streamlining workflows for resource management and status tracking. Labels support three positions: left labels outside the taskbar for identifiers like TaskName, right labels after the taskbar for metrics like Progress, and task labels overlaid on taskbars for prominent data like task titles. Left and right labels remain visible regardless of taskbar width, while task labels may clip for short tasks. Labels improve readability and provide immediate context, reducing the need for hovers or dialogs in large projects.

Configure task labels

Task labels are configured using the labelSettings property, mapping fields from the data source defined in taskFields (e.g., id to TaskID, name to TaskName). The component supports three label positions with specific use cases:

  • leftLabel: Displays content like task names or resource assignments to the left of taskbars, ideal for identifiers.
  • rightLabel: Shows metrics like progress percentages or durations to the right, suitable for completion data.
  • taskLabel: Overlays content like task titles or progress on taskbars, prominent but limited by taskbar width.

Use template literals for formatted labels, such as ${Progress}% for progress percentages. Ensure valid taskFields mappings to reference fields accurately.

The following example configures labels for task names, IDs, and progress:

function App() {
  const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    parentID: 'ParentID'
  };
  const labelSettings = {
    leftLabel: 'Task Id: ${TaskID}',
    rightLabel: 'Task Name: ${taskData.TaskName}',
    taskLabel: '${Progress}%'
  };
  ...
}

This code displays task names on the left, task IDs on the right, and formatted progress percentages on taskbars, ensuring clear visualization.

Customize labels with templates

For advanced scenarios, you can create custom label templates that provide complete control over label content and formatting

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';
import { data } from './datasource';

function App() {
  const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    parentID: 'ParentID'
  };
  const labelSettings = {
    leftLabel: 'Task ID: ${TaskID}',
    rightLabel: 'Task Name: ${taskData.TaskName}',
    taskLabel: '${Progress}%'
  };
  const projectStartDate = new Date('03/31/2019');
  const projectEndDate = new Date('04/18/2019');
  return <GanttComponent dataSource={data} taskFields={taskFields} labelSettings={labelSettings} height='450px' projectStartDate={projectStartDate} projectEndDate={projectEndDate}>
  </GanttComponent>
};
ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, LabelSettings, TaskFieldsModel } from '@syncfusion/ej2-react-gantt';
import { data } from './datasource';

function App() {
  const taskFields: TaskFieldsModel = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    parentID: 'ParentID'
  };
  const labelSettings: LabelSettings = {
    leftLabel: 'Task ID: ${TaskID}',
    rightLabel: 'Task Name: ${taskData.TaskName}',
    taskLabel: '${Progress}%'
  };
  const projectStartDate = new Date('03/31/2019');
  const projectEndDate = new Date('04/18/2019');
  return <GanttComponent dataSource={data} taskFields={taskFields} labelSettings={labelSettings} height='450px' projectStartDate={projectStartDate} projectEndDate={projectEndDate}>
  </GanttComponent>
};
ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

This code creates a left label with priority-based icons (e.g., red for high priority) and a right label with a progress bar, improving visual feedback. For responsive designs, ensure templates adapt to narrow screens, as task labels may be clipped on short taskbars.

Conditional label display with icons:

Create templates that show different content based on task properties:

// Left label template with conditional logic.
const leftLabelTemplate = (props: any) => {
    const { Priority, TaskName } = props;
    return (
      <div className="custom-left-label">
        {Priority === 'High' && <span className="priority-high">🔴</span>}
        {Priority === 'Medium' && <span className="priority-medium">🟡</span>}
        {Priority === 'Low' && <span className="priority-low">🟢</span>}
        <span>{TaskName}</span>
      </div>
    );
  };
// Right label template with progress indicators.
  const rightLabelTemplate = (props: any) => {
    const progress = props.Progress || 0;
    const duration = props.Duration || 0;
    return (
      <div className="custom-right-label">
        <div className="progress-container">
          <span className="progress-text">{progress}%</span>
          <div
            className="progress-bar"
            style={{ width: `${progress}%` }}
          />
        </div>
        <span className="duration-text">{duration} days</span>
      </div>
    );
  };

  const labelSettings: any = {
    leftLabel: leftLabelTemplate,
    rightLabel: rightLabelTemplate,
  };

Rich content labels with multiple data points:

Display complex information with formatted content and calculations:

// Task label template with multiple data points.

const getProgressClass = (progress: number): string => {
    if (progress >= 80) return 'high';
    if (progress >= 40) return 'medium';
    return 'low';
};

const taskLabelTemplate = (props: any): JSX.Element => {
    const taskName = props.TaskName || props.ganttProperties.taskName;
    const startDate = props.StartDate || props.ganttProperties.startDate;
    const endDate = props.EndDate || props.ganttProperties.endDate;
    const progress = props.Progress ?? props.ganttProperties.progress ?? 0;
    const resources = props.Resources || props.ganttProperties.resourceInfo;

    const formatDate = (date?: Date): string =>
        date ? date.toLocaleDateString('en-US', { month: 'short', day: '2-digit' }) : '';

    return (
        <div className="rich-task-label">
            <div className="task-info">
                <strong>{taskName}</strong>
                <small>
                    {formatDate(startDate)} – {formatDate(endDate)}
                </small>
            </div>

            <div className="task-meta">
                {resources && (
                    <span className="resource-count">
                        👥 {resources.length}
                    </span>
                )}
                <span className={`progress-badge progress-${getProgressClass(progress)}`}>
                    {progress}%
                </span>
            </div>
        </div>
    );
};

const labelSettings = {
    taskLabel: taskLabelTemplate
};

See also

Syncfusion AI Assistant

How can I help you?

Task labels in Vue Gantt Chart component

3 Feb 20264 minutes to read

Task labels

The Gantt Chart component maps any data source fields to task labels using the labelSettings.leftLabel, labelSettings.rightLabel, and labelSettings.taskLabel properties. You can customize the task labels with templates.

<template>
    <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :height="height" :taskFields="taskFields"
            :labelSettings="labelSettings" :projectStartDate="projectStartDate"
            :projectEndDate="projectEndDate"></ejs-gantt>
    </div>
</template>
<script setup>
import { GanttComponent as EjsGantt } from "@syncfusion/ej2-vue-gantt";
import { editingData } from './data-source.js';
const data = editingData;
const height = '450px';
const taskFields = {
    id: 'TaskId',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    parentID: 'ParentId'
};
const labelSettings = {
    leftLabel: 'Task Id: ${taskData.TaskId}',
    rightLabel: 'Task Name: ${taskData.TaskName}',
    taskLabel: '${Progress}%'
};
const projectStartDate = new Date('03/28/2019');
const projectEndDate = new Date('04/20/2019');
</script>
<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :height = "height" :taskFields = "taskFields" :labelSettings="labelSettings" :projectStartDate="projectStartDate" :projectEndDate="projectEndDate"></ejs-gantt>
    </div>
</template>
<script>
import { GanttComponent } from "@syncfusion/ej2-vue-gantt";
import { editingData  } from './data-source.js';
export default {
name: "App",
components: {
"ejs-gantt":GanttComponent
},
  data: function() {
      return{
            data: editingData,
            height: '450px',
            taskFields: {
                id: 'TaskId',
                name: 'TaskName',
                startDate: 'StartDate',
                duration: 'Duration',
                progress: 'Progress',
                parentID: 'ParentId'
            },
            labelSettings: {
            leftLabel: 'Task Id: ${taskData.TaskId}',
            rightLabel:'Task Name: ${taskData.TaskName}',
            taskLabel: '${Progress}%'
        },
        projectStartDate: new Date('03/28/2019'),
        projectEndDate: new Date('04/20/2019'),
      };
  },
};
</script>